// generated from rosidl_generator_cpp/resource/msg__struct.hpp.em
// generated code does not contain a copyright notice

#ifndef VISION_MSGS__MSG__DETECTION2_D_ARRAY__STRUCT_HPP_
#define VISION_MSGS__MSG__DETECTION2_D_ARRAY__STRUCT_HPP_

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32) && defined(ERROR)
  #undef ERROR
#endif

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// include message dependencies
#include "std_msgs/msg/header.hpp"  // header
#include "vision_msgs/msg/detection2_d.hpp"  // detections

#ifndef _WIN32
# define DEPRECATED_vision_msgs_msg_Detection2DArray __attribute__((deprecated))
#else
# define DEPRECATED_vision_msgs_msg_Detection2DArray __declspec(deprecated)
#endif

namespace vision_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Detection2DArray_
{
  using Type = Detection2DArray_<ContainerAllocator>;

  explicit Detection2DArray_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    (void)_init;
  }

  explicit Detection2DArray_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
      std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _detections_type =
      std::vector<vision_msgs::msg::Detection2D_<ContainerAllocator>, typename ContainerAllocator::template rebind<vision_msgs::msg::Detection2D_<ContainerAllocator>>::other>;
  _detections_type detections;

  // setters for named parameter idiom
  Type * set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return this;
  }
  Type * set__detections(
    const std::vector<vision_msgs::msg::Detection2D_<ContainerAllocator>, typename ContainerAllocator::template rebind<vision_msgs::msg::Detection2D_<ContainerAllocator>>::other> & _arg)
  {
    this->detections = _arg;
    return this;
  }

  // constants

  // pointer types
  using RawPtr =
      vision_msgs::msg::Detection2DArray_<ContainerAllocator> *;
  using ConstRawPtr =
      const vision_msgs::msg::Detection2DArray_<ContainerAllocator> *;
  using SharedPtr =
      std::shared_ptr<vision_msgs::msg::Detection2DArray_<ContainerAllocator>>;
  using ConstSharedPtr =
      std::shared_ptr<vision_msgs::msg::Detection2DArray_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      vision_msgs::msg::Detection2DArray_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
      std::unique_ptr<vision_msgs::msg::Detection2DArray_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      vision_msgs::msg::Detection2DArray_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
      std::unique_ptr<vision_msgs::msg::Detection2DArray_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
      std::weak_ptr<vision_msgs::msg::Detection2DArray_<ContainerAllocator>>;
  using ConstWeakPtr =
      std::weak_ptr<vision_msgs::msg::Detection2DArray_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED_vision_msgs_msg_Detection2DArray
    std::shared_ptr<vision_msgs::msg::Detection2DArray_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED_vision_msgs_msg_Detection2DArray
    std::shared_ptr<vision_msgs::msg::Detection2DArray_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Detection2DArray_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->detections != other.detections) {
      return false;
    }
    return true;
  }
  bool operator!=(const Detection2DArray_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Detection2DArray_

// alias to use template instance with default allocator
using Detection2DArray =
    vision_msgs::msg::Detection2DArray_<std::allocator<void>>;

// constants requiring out of line definition

}  // namespace msg

}  // namespace vision_msgs

#endif  // VISION_MSGS__MSG__DETECTION2_D_ARRAY__STRUCT_HPP_
